;;;; levenshtein-byte-test.scm -*- Scheme -*-

(import test)

(import levenshtein-byte)

(test-begin "Byte Strings")

(test-group "Byte"

  (test-group "Simple Strings"
    (test 2 (levenshtein-distance/byte "adresse" "address"))
    (test 2 (levenshtein-distance/byte "adresse" "addressee"))
    (test 2 (levenshtein-distance/byte "gambol"  "gumbo"))
    (test 2 (levenshtein-distance/byte "gumbo"   "gambol"))
    (test 3 (levenshtein-distance/byte "gumbo"   "bumble"))
    (test 4 (levenshtein-distance/byte "a"       "abcde"))
    (test 4 (levenshtein-distance/byte "abcde"   "a"))
  )

  (test-group "Simple Blobs"
    (test 2 (levenshtein-distance/byte '#${1 2 3 4} '#${1 3 2 4}))
    (test 3 (levenshtein-distance/byte '#${1 2 3 4} '#${1 3 2 5}))
  )
)

;;

(import levenshtein-transpose-byte)

(test-group "Byte w/ Transpose"

  (test-group "Simple Strings"
    (test 2 (levenshtein-distance/transpose-byte "adresse" "address"))
    (test 2 (levenshtein-distance/transpose-byte "adresse" "addressee"))
    (test 2 (levenshtein-distance/transpose-byte "gambol"  "gumbo"))
    (test 2 (levenshtein-distance/transpose-byte "gumbo"   "gambol"))
    (test 3 (levenshtein-distance/transpose-byte "gumbo"   "bumble"))
    (test 4 (levenshtein-distance/transpose-byte "a"       "abcde"))
    (test 4 (levenshtein-distance/transpose-byte "abcde"   "a"))
  )

  (test-group "Simple Blobs"
    (test 1 (levenshtein-distance/transpose-byte '#${1 2 3 4} '#${1 3 2 4}))
    (test 2 (levenshtein-distance/transpose-byte '#${1 2 3 4} '#${1 3 2 5}))
  )
)

(test-end "Byte Strings")

(test-exit)
